#ifndef _BINDINGS_H__
#define _BINDINGS_H__

int get_file_number();
int change(int file_no);
int get_files();
int get_file_length(int file_no);
int get_file_tab_width(int file_no);
char *get_full_filename(int file_no);
char *get_filename(int file_no);
char *get_path(int file_no);
char *get_file(int file_no);
int has_selection();
int selection_start();
int selection_end();
void move(int relative_movement);
void move_to(int index);
int current_position(void);
int  buffer_size(void);
void insert_in(int file_no, int pos, char* text);
void insert(char* text);
void move_to_line (int index);
void move_lines (int relative_movement);
int current_line();
char* get_text(int begin,int end);
char get_current_char();
char get_next_char();
void delete_text(int start, int end);
void delete_text_in(int file_no, int start, int end);
void forward_delete (int n);
void backward_delete (int index);
void undo();
void undo_last(int file_no);
void redo();
void redo_last(int file_no);
void cut();
void cut_text(int file_no);
void copy();
void copy_text(int file_no);
void paste();
void paste_text(int file_no);
void clear();
void clear_text(int file_no);
void clear_entry();
void comment();
void comment_selection(int file_no);
void select_area(int from, int to);
void select_text(int file_no, int from, int to);
void select_current();
void select_all();
void select_all_text(int file_no);
void highlight_syntax(int file_no);
void new_window();
void new_file(char *filename);
void open_file(char *filename);
void close_file(int file_no);
void save_all_files();
void close_all_files();
int find(char *text);
int find_in(int file_no, char *text);
int find_regex(char *text);
int find_regex_in(int file_no, char *text);
int replace(char *search_text, char *replacer);
int replace_in(int file_no, char *search_text, char *replacer);
int replace_all(char *search_text, char *replacer);
int replace_all_in(int file_no, char *search_text, char *replacer);

#endif
