#include "declarations.h"

void free_string(GtkWidget *widget, gchar *string);
void set_dead(GtkWidget *widget, gpointer data);

void file_dne_error(gchar *filename, GtkSignalFunc callback)
{
   GtkWidget *error_window;
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *yes;
   GtkWidget *no;
   gchar *string;
   gchar line1[384];
   
   string = g_strdup(filename);
   error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(error_window), window_box);
   gtk_widget_show(window_box);   

   g_snprintf(line1, 384, _("%s does not exist."), string);
   label = gtk_label_new(line1);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   label = gtk_label_new(_("Would you like to create it?"));
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   no = gnome_stock_button(GNOME_STOCK_BUTTON_NO);
   gtk_signal_connect_object(GTK_OBJECT(no), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), no, FALSE, FALSE, 10);
   gtk_widget_show(no);

   yes = gnome_stock_button(GNOME_STOCK_BUTTON_YES);
   gtk_signal_connect(GTK_OBJECT(yes), "clicked", GTK_SIGNAL_FUNC(file_create), string);
   gtk_signal_connect(GTK_OBJECT(yes), "clicked", callback, string);
   gtk_signal_connect_object(GTK_OBJECT(yes), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), yes, FALSE, FALSE, 10);
   gtk_widget_show(yes);

   gtk_signal_connect(GTK_OBJECT(error_window), "destroy", GTK_SIGNAL_FUNC(free_string), string);
   gtk_widget_show(error_window);  
}


void file_exists_error(gchar *filename, GtkSignalFunc callback)
{
   GtkWidget *error_window;
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *yes;
   GtkWidget *no;
   gchar *string;
   gchar line1[384];
   
   string = g_strdup(filename);
   error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(error_window), window_box);
   gtk_widget_show(window_box);   

   g_snprintf(line1, 384, _("%s already exists."), string);
   label = gtk_label_new(line1);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   label = gtk_label_new(_("Would you like to overwrite it?"));
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   no = gnome_stock_button(GNOME_STOCK_BUTTON_NO);
   gtk_signal_connect_object(GTK_OBJECT(no), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), no, FALSE, FALSE, 10);
   gtk_widget_show(no);

   yes = gnome_stock_button(GNOME_STOCK_BUTTON_YES);
   gtk_signal_connect(GTK_OBJECT(yes), "clicked", callback, string);
   gtk_signal_connect_object(GTK_OBJECT(yes), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), yes, FALSE, FALSE, 10);
   gtk_widget_show(yes);

   gtk_signal_connect(GTK_OBJECT(error_window), "destroy", GTK_SIGNAL_FUNC(free_string), string);
   gtk_widget_show(error_window);  
}

void file_not_saved(char *filename, GdsFile *file, GtkSignalFunc func_yes, GtkSignalFunc func_no)
{
   GtkWidget *error_window;
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *yes;
   GtkWidget *no;
   GtkWidget *cancel;
   gchar line1[384];
   
   error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(error_window), window_box);
   gtk_widget_show(window_box);   

   g_snprintf(line1, 384, _("%s has not been saved."), filename);
   label = gtk_label_new(line1);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   label = gtk_label_new(_("Would you like to save it now?"));
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   cancel = gnome_stock_button(GNOME_STOCK_BUTTON_CANCEL);
   gtk_signal_connect_object(GTK_OBJECT(cancel), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), cancel, FALSE, FALSE, 10);
   gtk_widget_show(cancel);

   no = gnome_stock_button(GNOME_STOCK_BUTTON_NO);
   gtk_signal_connect(GTK_OBJECT(no), "clicked", GTK_SIGNAL_FUNC(close_file_error_cb), file);
   if(func_no != NULL) gtk_signal_connect(GTK_OBJECT(no), "clicked", func_no, 0);
   gtk_signal_connect_object(GTK_OBJECT(no), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), no, FALSE, FALSE, 10);
   gtk_widget_show(no);

   yes = gnome_stock_button(GNOME_STOCK_BUTTON_YES);
   gtk_signal_connect(GTK_OBJECT(yes), "clicked", GTK_SIGNAL_FUNC(save_file_error_cb), file);
   gtk_signal_connect(GTK_OBJECT(yes), "clicked", GTK_SIGNAL_FUNC(close_file_error_cb), file);
   if(func_yes != NULL) gtk_signal_connect(GTK_OBJECT(yes), "clicked", func_yes, 0);
   gtk_signal_connect_object(GTK_OBJECT(yes), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), yes, FALSE, FALSE, 10);
   gtk_widget_show(yes);

   gtk_widget_show(error_window);  
}

void file_not_saved_no_close(char *filename, GdsFile *file, GtkSignalFunc func_yes, GtkSignalFunc func_no)
{
   GtkWidget *error_window;
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *yes;
   GtkWidget *no;
   GtkWidget *cancel;
   gchar line1[384];
   
   error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(error_window), window_box);
   gtk_widget_show(window_box);   

   g_snprintf(line1, 384, _("%s has not been saved."), filename);
   label = gtk_label_new(line1);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   label = gtk_label_new(_("Would you like to save it now?"));
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   cancel = gnome_stock_button(GNOME_STOCK_BUTTON_CANCEL);
   gtk_signal_connect_object(GTK_OBJECT(cancel), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), cancel, FALSE, FALSE, 10);
   gtk_widget_show(cancel);

   no = gnome_stock_button(GNOME_STOCK_BUTTON_NO);
   if(func_no != NULL) gtk_signal_connect(GTK_OBJECT(no), "clicked", func_no, file);
   gtk_signal_connect_object(GTK_OBJECT(no), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), no, FALSE, FALSE, 10);
   gtk_widget_show(no);

   yes = gnome_stock_button(GNOME_STOCK_BUTTON_YES);
   gtk_signal_connect(GTK_OBJECT(yes), "clicked", GTK_SIGNAL_FUNC(save_file_error_cb), 0);
   if(func_yes != NULL) gtk_signal_connect(GTK_OBJECT(yes), "clicked", func_yes, file);
   gtk_signal_connect_object(GTK_OBJECT(yes), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), yes, FALSE, FALSE, 10);
   gtk_widget_show(yes);

   gtk_widget_show(error_window);  
}

void read_error(gchar *filename)
{
   GtkWidget *error_window;
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *close;
   gchar line1[384];
   
   error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(error_window), window_box);
   gtk_widget_show(window_box);   

   g_snprintf(line1, 384, _("%s could not be read."), filename);
   label = gtk_label_new(line1);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   close = gnome_stock_button(GNOME_STOCK_BUTTON_CLOSE);
   gtk_signal_connect_object(GTK_OBJECT(close), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), close, FALSE, FALSE, 10);
   gtk_widget_show(close);

   gtk_widget_show(error_window);  
}


void save_error(gchar *filename)
{
   GtkWidget *error_window;
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *close;
   gchar line1[384];
   
   error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(error_window), window_box);
   gtk_widget_show(window_box);   

   g_snprintf(line1, 384, _("%s could not be saved."), filename);
   label = gtk_label_new(line1);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   close = gnome_stock_button(GNOME_STOCK_BUTTON_CLOSE);
   gtk_signal_connect_object(GTK_OBJECT(close), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), close, FALSE, FALSE, 10);
   gtk_widget_show(close);

   gtk_widget_show(error_window);  
}


void read_only(gchar *filename)
{
   GtkWidget *error_window;
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *close;
   gchar line1[384];
   
   error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(error_window), window_box);
   gtk_widget_show(window_box);   

   g_snprintf(line1, 384, _("%s opened as read only."), filename);
   label = gtk_label_new(line1);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   close = gnome_stock_button(GNOME_STOCK_BUTTON_CLOSE);
   gtk_signal_connect_object(GTK_OBJECT(close), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), close, FALSE, FALSE, 10);
   gtk_widget_show(close);

   gtk_widget_show(error_window);  
}


void create_error(gchar *filename)
{
   GtkWidget *error_window;
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *close;
   gchar line1[384];
   
   error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(error_window), window_box);
   gtk_widget_show(window_box);   

   g_snprintf(line1, 384, _("%s could not be created."), filename);
   label = gtk_label_new(line1);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   close = gnome_stock_button(GNOME_STOCK_BUTTON_CLOSE);
   gtk_signal_connect_object(GTK_OBJECT(close), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(error_window));
   gtk_box_pack_end(GTK_BOX(button_box), close, FALSE, FALSE, 10);
   gtk_widget_show(close);

   gtk_widget_show(error_window);  
}

static GtkWidget *generic_error_window;

void generic_dialog_with_text(gchar *text)
{
   GtkWidget *window_box;
   GtkWidget *label;
   GtkWidget *button_box;
   GtkWidget *close;

   if(generic_error_window) gtk_widget_destroy(generic_error_window);

   generic_error_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(generic_error_window), 10);

   window_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(generic_error_window), window_box);
   gtk_widget_show(window_box);   

   label = gtk_label_new(text);
   gtk_box_pack_start(GTK_BOX(window_box), label, FALSE, FALSE, 10);   
   gtk_widget_show(label);
   
   button_box = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(window_box), button_box, FALSE, FALSE, 10);      
   gtk_widget_show(button_box);

   close = gnome_stock_button(GNOME_STOCK_BUTTON_CLOSE);
   gtk_signal_connect_object(GTK_OBJECT(close), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(generic_error_window));
   gtk_box_pack_end(GTK_BOX(button_box), close, FALSE, FALSE, 10);
   gtk_widget_show(close);
   gtk_signal_connect(GTK_OBJECT(generic_error_window), "destroy", GTK_SIGNAL_FUNC(set_dead), 0);
   gtk_widget_show(generic_error_window);  
}

void set_dead(GtkWidget *widget, gpointer data)
{
   generic_error_window = NULL;
}

void free_string(GtkWidget *widget, gchar *string)
{
   g_free(string);
}