
#ifndef FILE_IO_H
#define FILE_IO_H
#include "widgets/gnomefilelist.h"

void new_window_cb(GtkWidget *widget, gpointer data);
void new_file_real(gchar *filename);
void new_file_cb(GtkWidget *widget, gpointer data);
void open_file_real(gchar *filename);
void open_file_cb(GtkWidget *widget, gpointer data);
void open_file_cb_continue(GtkWidget *widget, GnomeFileList *file_list);
void open_file_error_cb(GtkWidget *widget, gchar *filename);
void revert_current_file(GtkWidget *widget, gpointer data);
void save_file_cb(GtkWidget *widget, gpointer data);
void save_file_error_cb(GtkWidget *widget, GdsFile *file);
void save_file_real(GdsFile *gds_file);
void save_file_as_cb(GtkWidget *widget, gpointer data);
void save_file_as_continue(GtkWidget *widget, GnomeFileList *file_list);
void save_file_as_error_cb(GtkWidget *widget, gchar *filename);
void save_file_as_real(GdsFile *gds_file, gchar *filename);
void save_all_files_cb(GtkWidget *widget, gpointer data);
void close_file_cb(GtkWidget *widget, gpointer data);
void close_file_error_cb(GtkWidget *widget, GdsFile *file);
void close_file_real(GdsFile *file);
void close_all_files_cb(GtkWidget *widget, gpointer data);
gboolean open_file_add_text(GtkWidget *text, gchar *filename);
gboolean check_if_file_exists(gchar *filename);
gboolean check_if_file_can_exist(gchar *filename);
gboolean check_if_read_only(gchar *filename, GdsFile *temp, gboolean set_ro, gboolean do_error);
void file_create(GtkWidget *widget, gchar *filename);
GList *build_file_list();

void setup_recent_files_list(gint max_files);
void build_recent_files_menu(GList *file_strings);
void recent_files_callback(GtkWidget *widget, gpointer data);
void add_file_to_recent_list(gchar *filename);
void kill_old_recent_menu();

extern gchar *last_dir;
extern GList *recent_files;
#endif