#include "declarations.h"

void get_prefs()
{
   GtkWidget *win;
   GtkWidget *text_widget;
   GtkStyle *style;
   gchar *text;
   gchar *home = NULL;
   gchar *user = NULL;
   gchar *hostname = NULL;
   home = getenv("HOME");
   user = getenv("USER");
   hostname = getenv("HOSTNAME");
   strncpy(default_preferences.default_dir, home, sizeof(default_preferences.default_dir));
   g_snprintf(default_preferences.projects_dir, sizeof(default_preferences.projects_dir), "%s/Projects", home);
   strncpy(default_preferences.name, user ? user : "user", sizeof(default_preferences.name));
   g_snprintf(default_preferences.email, sizeof(default_preferences.email), "%s@%s", user ? user:"user", hostname ? hostname : "localhost");
   default_preferences.save_session = TRUE;
   default_preferences.open_session = TRUE;
   default_preferences.history = general_preferences.history = 5;
   default_preferences.undo_max  = general_preferences.undo_max = 20;
   default_preferences.notebook_tab_position = general_preferences.notebook_tab_position = GTK_POS_TOP;
   default_preferences.use_gtk_theme = general_preferences.use_gtk_theme = FALSE;
   default_preferences.font = NULL;
   general_preferences.font = default_preferences.font;
   strcpy(default_preferences.font_name, "-dec-terminal-bold-r-normal-*-*-140-*-*-c-*-iso8859-1");
   strcpy(general_preferences.font_name, default_preferences.font_name);
   win = gtk_window_new(GTK_WINDOW_DIALOG);   
   text_widget = gtk_text_new(0, 0);
   gtk_container_add(GTK_CONTAINER(win), text_widget);
   gtk_widget_realize(text_widget);
   style = text_widget->style;
   default_preferences.fg = style->text[GTK_STATE_NORMAL];
   default_preferences.bg = style->bg[GTK_STATE_NORMAL];
   default_preferences.s_fg = style->text[GTK_STATE_SELECTED];
   default_preferences.s_bg = style->bg[GTK_STATE_SELECTED];
   gtk_widget_destroy(win);
   default_preferences.syntax = TRUE;   
   default_preferences.auto_indent = TRUE;
   default_preferences.use_spaces = FALSE;
   default_preferences.spaces = 5;

   if(!gnome_config_has_section("/" PACKAGE "/General"))
      save_defaults();
   text = gnome_config_get_string("/" PACKAGE "/General/default_dir");
   strcpy(general_preferences.default_dir, text);
   g_free(text);

   text = gnome_config_get_string("/" PACKAGE "/General/projects_dir");
   strcpy(general_preferences.projects_dir, text);
   g_free(text);

   general_preferences.save_session = gnome_config_get_int("/" PACKAGE "/General/save_session");
   general_preferences.open_session = gnome_config_get_int("/" PACKAGE "/General/open_session");
   text = gnome_config_get_string("/" PACKAGE "/General/session_name");
   if(text && general_preferences.open_session) { g_free(session_file); session_file = text; }
   else g_free(text);
   general_preferences.history = gnome_config_get_int("/" PACKAGE "/General/history_items");
   general_preferences.undo_max = gnome_config_get_int("/" PACKAGE "/General/undo_max");
   general_preferences.notebook_tab_position = gnome_config_get_int("/" PACKAGE "/General/tab_position");
   text = gnome_config_get_string("/" PACKAGE "/User Settings/name");
   strcpy(general_preferences.name, text);
   g_free(text);

   text = gnome_config_get_string("/" PACKAGE "/User Settings/email");
   strcpy(general_preferences.email, text);
   g_free(text);

   text = gnome_config_get_string("/" PACKAGE "/Fonts/font_name");
   if(strlen(text) > 1)
   {
      strcpy(general_preferences.font_name, text);
      g_free(text);
   }

   general_preferences.use_gtk_theme = gnome_config_get_int("/" PACKAGE "/Colors/use_gtk_theme");
   general_preferences.bg.red = gnome_config_get_int("/" PACKAGE "/Colors/bg.red");
   general_preferences.bg.green = gnome_config_get_int("/" PACKAGE "/Colors/bg.green");
   general_preferences.bg.blue = gnome_config_get_int("/" PACKAGE "/Colors/bg.blue");
   general_preferences.fg.red = gnome_config_get_int("/" PACKAGE "/Colors/fg.red");
   general_preferences.fg.green = gnome_config_get_int("/" PACKAGE "/Colors/fg.green");
   general_preferences.fg.blue = gnome_config_get_int("/" PACKAGE "/Colors/fg.blue");
   general_preferences.s_bg.red = gnome_config_get_int("/" PACKAGE "/Colors/s_bg.red");
   general_preferences.s_bg.green = gnome_config_get_int("/" PACKAGE "/Colors/s_bg.green");
   general_preferences.s_bg.blue = gnome_config_get_int("/" PACKAGE "/Colors/s_bg.blue");
   general_preferences.s_fg.red = gnome_config_get_int("/" PACKAGE "/Colors/s_fg.red");
   general_preferences.s_fg.green = gnome_config_get_int("/" PACKAGE "/Colors/s_fg.green");
   general_preferences.s_fg.blue = gnome_config_get_int("/" PACKAGE "/Colors/s_fg.blue");

   general_preferences.syntax = gnome_config_get_int("/" PACKAGE "/File Settings/syntax");
   general_preferences.auto_indent = gnome_config_get_int("/" PACKAGE "/File Settings/auto_indent");
   general_preferences.use_spaces = gnome_config_get_int("/" PACKAGE "/File Settings/use_spaces");   
   general_preferences.spaces = gnome_config_get_int("/" PACKAGE "/File Settings/spaces");
}

void save_prefs()
{
   gchar *text;
   text = general_preferences.default_dir;
   gnome_config_set_string("/" PACKAGE "/General/default_dir", text);
   text = general_preferences.projects_dir;
   gnome_config_set_string("/" PACKAGE "/General/projects_dir", text);
   gnome_config_set_int("/" PACKAGE "/General/save_session", general_preferences.save_session);
   gnome_config_set_int("/" PACKAGE "/General/open_session", general_preferences.open_session);
   gnome_config_set_int("/" PACKAGE "/General/history_items", general_preferences.history);
   gnome_config_set_int("/" PACKAGE "/General/undo_max", general_preferences.undo_max);
   gnome_config_set_int("/" PACKAGE "/General/tab_position", general_preferences.notebook_tab_position);
   
   text = general_preferences.name;
   gnome_config_set_string("/" PACKAGE "/User Settings/name", text);
   text = general_preferences.email;
   gnome_config_set_string("/" PACKAGE "/User Settings/email", text);

   text = general_preferences.font_name;
   gnome_config_set_string("/" PACKAGE "/Fonts/font_name", text);

   gnome_config_set_int("/" PACKAGE "/Colors/use_gtk_theme", general_preferences.use_gtk_theme);
   gnome_config_set_int("/" PACKAGE "/Colors/bg.red", general_preferences.bg.red);
   gnome_config_set_int("/" PACKAGE "/Colors/bg.green", general_preferences.bg.green);
   gnome_config_set_int("/" PACKAGE "/Colors/bg.blue", general_preferences.bg.blue);
   gnome_config_set_int("/" PACKAGE "/Colors/fg.red", general_preferences.fg.red);
   gnome_config_set_int("/" PACKAGE "/Colors/fg.green", general_preferences.fg.green);
   gnome_config_set_int("/" PACKAGE "/Colors/fg.blue", general_preferences.fg.blue);
   gnome_config_set_int("/" PACKAGE "/Colors/s_bg.red", general_preferences.s_bg.red);
   gnome_config_set_int("/" PACKAGE "/Colors/s_bg.green", general_preferences.s_bg.green);
   gnome_config_set_int("/" PACKAGE "/Colors/s_bg.blue", general_preferences.s_bg.blue);
   gnome_config_set_int("/" PACKAGE "/Colors/s_fg.red", general_preferences.s_fg.red);
   gnome_config_set_int("/" PACKAGE "/Colors/s_fg.green", general_preferences.s_fg.green);
   gnome_config_set_int("/" PACKAGE "/Colors/s_fg.blue", general_preferences.s_fg.blue);

   gnome_config_set_int("/" PACKAGE "/File Settings/syntax", general_preferences.syntax);
   gnome_config_set_int("/" PACKAGE "/File Settings/auto_indent", general_preferences.auto_indent);
   gnome_config_set_int("/" PACKAGE "/File Settings/use_spaces", general_preferences.use_spaces);
   gnome_config_set_int("/" PACKAGE "/File Settings/spaces", general_preferences.spaces);
   gnome_config_sync();
}

void save_defaults()
{
   gchar *text;
   text = default_preferences.default_dir;
   gnome_config_set_string("/" PACKAGE "/General/default_dir", text);
   text = default_preferences.projects_dir;
   gnome_config_set_string("/" PACKAGE "/General/projects_dir", text);
   gnome_config_set_int("/" PACKAGE "/General/save_session", default_preferences.save_session);
   gnome_config_set_int("/" PACKAGE "/General/open_session", default_preferences.open_session);
   gnome_config_set_int("/" PACKAGE "/General/history_items", default_preferences.history);
   gnome_config_set_int("/" PACKAGE "/General/undo_max", default_preferences.undo_max);
   gnome_config_set_int("/" PACKAGE "/General/tab_position", default_preferences.notebook_tab_position);   

   text = default_preferences.name;
   gnome_config_set_string("/" PACKAGE "/User Settings/name", text);
   text = default_preferences.email;
   gnome_config_set_string("/" PACKAGE "/User Settings/email", text);

   text = default_preferences.font_name;
   gnome_config_set_string("/" PACKAGE "/Fonts/font_name", text);

   gnome_config_set_int("/" PACKAGE "/Colors/use_gtk_theme", default_preferences.use_gtk_theme);
   gnome_config_set_int("/" PACKAGE "/Colors/bg.red", default_preferences.bg.red);
   gnome_config_set_int("/" PACKAGE "/Colors/bg.green", default_preferences.bg.green);
   gnome_config_set_int("/" PACKAGE "/Colors/bg.blue", default_preferences.bg.blue);
   gnome_config_set_int("/" PACKAGE "/Colors/fg.red", default_preferences.fg.red);
   gnome_config_set_int("/" PACKAGE "/Colors/fg.green", default_preferences.fg.green);
   gnome_config_set_int("/" PACKAGE "/Colors/fg.blue", default_preferences.fg.blue);
   gnome_config_set_int("/" PACKAGE "/Colors/s_bg.red", default_preferences.s_bg.red);
   gnome_config_set_int("/" PACKAGE "/Colors/s_bg.green", default_preferences.s_bg.green);
   gnome_config_set_int("/" PACKAGE "/Colors/s_bg.blue", default_preferences.s_bg.blue);
   gnome_config_set_int("/" PACKAGE "/Colors/s_fg.red", default_preferences.s_fg.red);
   gnome_config_set_int("/" PACKAGE "/Colors/s_fg.green", default_preferences.s_fg.green);
   gnome_config_set_int("/" PACKAGE "/Colors/s_fg.blue", default_preferences.s_fg.blue);

   gnome_config_set_int("/" PACKAGE "/File Settings/syntax", default_preferences.syntax);
   gnome_config_set_int("/" PACKAGE "/File Settings/auto_indent", default_preferences.auto_indent);
   gnome_config_set_int("/" PACKAGE "/File Settings/use_spaces", default_preferences.use_spaces);
   gnome_config_set_int("/" PACKAGE "/File Settings/spaces", default_preferences.spaces);
   gnome_config_sync();
}

void save_session_pref()
{
   gnome_config_set_string("/" PACKAGE "/General/session_name", session_file);
   gnome_config_sync();
}
