#include "declarations.h"
#include "insert.h"
#include "time.h"
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>


void insert_date_time(GtkWidget *widget, gpointer data)
{
   char buffer[128];
   time_t cur_time;
   struct tm *time_ptr;
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   time(&cur_time);
   time_ptr = localtime(&cur_time);
   strftime(buffer, sizeof(buffer), "%a %b %d %X %Z %Y", time_ptr);
   gtk_editable_insert_text(editable, buffer, strlen(buffer), (gint *)&editable->current_pos);
}

void insert_username(GtkWidget *widget, gpointer data)
{
   gchar *text;
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   text = g_new(char, strlen(getenv("USER"))+1);
   strcpy(text, getenv("USER"));
   gtk_editable_insert_text(editable, text, strlen(text), (gint *)&editable->current_pos);
}

void insert_name(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, general_preferences.name, strlen(general_preferences.name), (gint *)&editable->current_pos);
}

void insert_email(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, general_preferences.email, strlen(general_preferences.email), (gint *)&editable->current_pos);
}

// C/C++ related tags

void insert_gpl_notice(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;

   gchar *gpl_notice = {
   "/*\n"
   " *  This program is free software; you can redistribute it and/or modify\n"
   " *  it under the terms of the GNU General Public License as published by\n"
   " *  the Free Software Foundation; either version 2 of the License, or\n"
   " *  (at your option) any later version.\n"
   " *\n"
   " *  This program is distributed in the hope that it will be useful,\n"
   " *  but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
   " *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
   " *  GNU Library General Public License for more details.\n"
   " *\n"
   " *  You should have received a copy of the GNU Library General Public License\n"
   " *  along with this program; if not, write to the Free Software\n"
   " *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.\n"
   " */\n"
   };

   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, gpl_notice, strlen(gpl_notice), (gint *)&editable->current_pos);
}

void insert_gpl_noticepp(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;

   gchar gpl_notice[] = {
   "// This program is free software; you can redistribute it and/or modify\n"
   "// it under the terms of the GNU General Public License as published by\n"
   "// the Free Software Foundation; either version 2 of the License, or\n"
   "// (at your option) any later version.\n"
   "//\n"
   "// This program is distributed in the hope that it will be useful,\n"
   "// but WITHOUT ANY WARRANTY; without even the implied warranty of\n"
   "// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n"
   "// GNU Library General Public License for more details.\n"
   "//\n"
   "// You should have received a copy of the GNU Library General Public License\n"
   "// along with this program; if not, write to the Free Software\n"
   "// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.\n"
   "\n"
   };

   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, gpl_notice, strlen(gpl_notice), (gint *)&editable->current_pos);
}

void insert_changelog_string(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   insert_date_time(widget, data);
   gtk_editable_insert_text(editable, " ", 1, (gint *)&editable->current_pos);
   insert_name(widget, data);
   gtk_editable_insert_text(editable, " <", 2, (gint *)&editable->current_pos);
   insert_email(widget, data);
   gtk_editable_insert_text(editable, ">", 1, (gint *)&editable->current_pos);
}

void insert_comment(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "/*\n *\n */", 9, (gint *)&editable->current_pos);
}

void insert_commentpp(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "//", 2, (gint *)&editable->current_pos);
}

// HTML related tags

void insert_html_title(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<title></title>", 15, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 8;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_comment(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<!--//-->", 9, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 5;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_font_size(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<font size=></font>", 19, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 8;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_font_color(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<font color=></font>", 20, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 8;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_font_face(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<font face=\"\"></font>", 21, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 9;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_font_bold(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<b></b>", 20, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 4;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_font_italic(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<i></i>", 20, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 4;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_form(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<form name=\"\"></form>", 21, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 9;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_form_button(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<input type=\"button\" name=\"\" value=\"\"></input>", 46, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 19;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_form_submit(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<input type=\"submit\" name=\"\" value=\"\"></input>", 46, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 19;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_form_text(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<input type=\"text\" name=\"\" value=\"\"></input>", 44, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 19;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_form_textarea(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<textarea name=\"\" rows= cols=></textarea>", 41, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 25;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_form_list(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<select name=\"\"></select>", 24, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 11;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_form_option(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, "<option name=\"\"></option>", 24, (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 11;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_html(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   gchar string[] = "<html></html>";
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, string, strlen(string), (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 7;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_head(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   gchar string[] = "<head></head>";
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, string, strlen(string), (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 7;
   gtk_extext_set_position(editable, new_pos);
}

void insert_html_body(GtkWidget *widget, gpointer data)
{
   GtkEditable *editable;
   gint new_pos = 0;
   gchar string[] = "<body background=\"\" bgcolor=#000000 text=#FFFFFF></body>";
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, string, strlen(string), (gint *)&editable->current_pos);
   new_pos = editable->current_pos - 38;
   gtk_extext_set_position(editable, new_pos);
}

void insert_menu_text(GtkWidget *widget, MenuEntry *entry)
{
   GtkEditable *editable;
   gint new_pos = 0;
   editable = GTK_EDITABLE(cur_file->text);
   gtk_editable_insert_text(editable, entry->string, strlen(entry->string), (gint *)&editable->current_pos);
   new_pos = editable->current_pos - entry->value;
   gtk_extext_set_position(editable, new_pos >= 0 ? new_pos : 0);
}

void insert_ascii_char_cb(GtkWidget *widget, gpointer data)
{
   GnomeAsciiList *ascii;
   widget = gnome_ascii_list_new();
   ascii = GNOME_ASCII_LIST(widget);
   gtk_signal_connect(GTK_OBJECT(ascii->insert_button), "clicked", GTK_SIGNAL_FUNC(insert_ascii_char), ascii);
   gtk_signal_connect_object(GTK_OBJECT(ascii->close_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(ascii));
   gtk_widget_show(widget);
}

void insert_ascii_char(GtkWidget *widget, GnomeAsciiList *ascii)
{
   gchar *text;
   if(!cur_file) return;
   text = gtk_entry_get_text(GTK_ENTRY(ascii->entry));
   gtk_editable_insert_text(GTK_EDITABLE(cur_file->text), text, strlen(text), (gint *)&GTK_EDITABLE(cur_file->text)->current_pos);
}

void insert_file_cb(GtkWidget *widget, gpointer data)
{
   file_selector = last_dir ? gnome_filelist_new_with_path(last_dir) : gnome_filelist_new_with_path(general_preferences.default_dir);
   gnome_filelist_set_title(GNOME_FILELIST(file_selector), _("Insert File..."));
   gtk_signal_connect(GTK_OBJECT(GNOME_FILELIST(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(insert_file_cb_continue), file_selector);
   gtk_signal_connect_object(GTK_OBJECT(GNOME_FILELIST(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(file_selector));
   gtk_signal_connect_object(GTK_OBJECT(GNOME_FILELIST(file_selector)->cancel_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(file_selector));
   gtk_widget_show(file_selector);
}

void insert_file_cb_continue(GtkWidget *widget, GnomeFileList *file_list)
{
   gchar *string;
   string = gnome_filelist_get_filename(GNOME_FILELIST(file_list));
   if(check_if_file_exists(string))
   {
      insert_file_real(string);
   }
   else
   {
      read_error(string);
   }
   g_free(string);
}

void insert_file_real(gchar *filename)
{
   gchar *temp = NULL;
   if(!cur_file) return;
   temp = get_path_from_filename(filename);
   if(temp && strcmp(filename, temp) != 0)
   {
      g_free(last_dir);
      last_dir = g_new(char, strlen(temp)+1);
      strcpy(last_dir, temp);
   }
   g_free(temp);
   open_file_add_text(cur_file->text, filename);
   adjust_sensitivity();
   display_message("File Inserted.", FLASH);
}

void runcmd_cb(GtkWidget *widget, gpointer data)
{
   g_return_if_fail(cur_file != NULL);
   widget = gnome_run_cmd_new();
   gtk_signal_connect(GTK_OBJECT(GNOME_RUN_CMD(widget)->run_button), "clicked", GTK_SIGNAL_FUNC(exec_command_cb), widget);
   gtk_signal_connect_object(GTK_OBJECT(GNOME_RUN_CMD(widget)->cancel_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(widget));
   gnome_run_cmd_set_history(GNOME_RUN_CMD(widget), build_glist_from_file("run.hist", general_preferences.history));
   gtk_widget_show(widget);
   gtk_widget_grab_focus(GNOME_RUN_CMD(widget)->entry);
}

void exec_command_callback(GdsFile *current);
void exec_command_cb(GtkWidget *widget, GnomeRunCmd *grc)
{
   gchar *string;
   FILE *exec;
   g_return_if_fail(cur_file != NULL);
   if(cur_file->compile_id != 0)
   {
      generic_dialog_with_text("File already has a process running.");
      return;
   }
   string = gtk_entry_get_text(GTK_ENTRY(grc->entry));

   add_string_to_file("run.hist", string);

   if(!(cur_file->compile_file = popen(string, "r")))
   {
      perror("Error opening process!");
      generic_dialog_with_text("Process could not be opened.");
      g_print("\a");
      return;
   }
   cur_file->compile_id = gdk_input_add(fileno(cur_file->compile_file), GDK_INPUT_READ, (GdkInputFunction)exec_command_callback, (gpointer)cur_file);
   gtk_widget_set_sensitive(GTK_WIDGET(cur_file), FALSE);
}

void exec_command_callback(GdsFile *current)
{
   gchar *path;
   gchar output[384];
   GtkEditable *editable;
   if(!g_list_find(files_list, (gpointer)current)) return;
   editable = GTK_EDITABLE(current->text);
   if(feof(current->compile_file))
   {
      pclose(current->compile_file);
      gdk_input_remove(current->compile_id);
      current->compile_id = 0;
      current->compile_file = NULL;
      gtk_widget_set_sensitive(GTK_WIDGET(cur_file), FALSE);
      return;
   }

   while(fgets(output, sizeof(output), current->compile_file))
   {
      gtk_editable_insert_text(editable, output, strlen(output), (gint *)&editable->current_pos);
   }
   return;
}
