#include "declarations.h"
#include "insert.h"
#include "about.h"
#include "macro_language.h"
#include "misc.h"

#include "xpm/selection.xpm"
#include "xpm/select_all.xpm"
#include "xpm/comment.xpm"
#include "xpm/dotslash.xpm"
#include "xpm/debug.xpm"
#include "xpm/window.xpm"
#include "xpm/arrow.xpm"
#include "xpm/gnu_gpl.xpm"

GtkWidget *filemenu;
GtkWidget *recentmenu;
GtkWidget *editmenu;
GtkWidget *searchmenu;
GtkWidget *insertmenu;
GtkWidget *insertmenutitle;
GtkWidget *buildmenu;
#ifdef USE_PYTHON
GtkWidget *scriptsmenu;
#endif
GtkWidget *settingsmenu;
GtkWidget *windowmenu;
GtkWidget *sessionmenu;
GtkWidget *helpmenu;
GtkWidget *file_menu_new;
GtkWidget *file_menu_open;
GtkWidget *file_menu_revert;
GtkWidget *file_menu_save;
GtkWidget *file_menu_saveas;
GtkWidget *file_menu_save_all;
GtkWidget *file_menu_close;
GtkWidget *file_menu_close_all;
GtkWidget *edit_menu_undo;
GtkWidget *edit_menu_redo;
GtkWidget *edit_popup_menu;

GnomeUIInfo recent_menu[] = {
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_END
};

GnomeUIInfo file_menu[] = {
   GNOMEUIINFO_MENU_NEW_ITEM(_("_New File"), _("New source file"), (gpointer)new_file_cb, 0),
   GNOMEUIINFO_MENU_OPEN_ITEM((gpointer)open_file_cb, 0),
   GNOMEUIINFO_MENU_REVERT_ITEM((gpointer)revert_current_file, 0),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_SAVE_ITEM((gpointer)save_file_cb, 0),
   GNOMEUIINFO_MENU_SAVE_AS_ITEM((gpointer)save_file_as_cb, 0),
   { GNOME_APP_UI_ITEM, _("Sa_ve All"), _("Save all open files"), (gpointer)save_all_files_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE, GDK_F10, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_CLOSE_ITEM(close_file_cb, 0),
   { GNOME_APP_UI_ITEM, _("C_lose All"), _("Close all open files"), (gpointer)close_all_files_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLOSE, GDK_F11, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_SUBTREE(_("Recent Files"), (gpointer)recent_menu),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_EXIT_ITEM((gpointer)pre_exit, 0),
   GNOMEUIINFO_END
};

GnomeUIInfo edit_menu[] = {
   GNOMEUIINFO_MENU_UNDO_ITEM((gpointer)undo_last_cb, 0),
   GNOMEUIINFO_MENU_REDO_ITEM((gpointer)redo_last_cb, 0),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_MENU_CUT_ITEM((gpointer)cut_text_cb, 0),
   GNOMEUIINFO_MENU_COPY_ITEM((gpointer)copy_text_cb, 0),
   GNOMEUIINFO_MENU_PASTE_ITEM((gpointer)paste_text_cb, 0),
   GNOMEUIINFO_SEPARATOR,
   { GNOME_APP_UI_ITEM, _("C_lear"), _("Clear selection"), (gpointer)clear_text_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR, GDK_F8, (GdkModifierType) 0, 0 },
#ifdef USE_PYTHON
   { GNOME_APP_UI_ITEM, _("Clear _Entry"), _("Clear the command entry"), (gpointer)clear_entry_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR, GDK_F8, GDK_SHIFT_MASK, 0 },
#endif
   GNOMEUIINFO_SEPARATOR,
   { GNOME_APP_UI_ITEM, _("Co_mment Selection"), _("Comment out the current selection"), (gpointer)comment_selection_cb, 0, 0, GNOME_APP_PIXMAP_DATA, comment_xpm, 'C', GDK_MOD1_MASK, 0 },
   { GNOME_APP_UI_ITEM, _("_Select Current"), _("Select the current word"), (gpointer)select_current_cb, 0, 0, GNOME_APP_PIXMAP_DATA, selection_xpm, 0, (GdkModifierType) 0, 0 },
   { GNOME_APP_UI_ITEM, _("Select _All"), _("Select the entire document"), (gpointer)select_all_text_cb, 0, 0, GNOME_APP_PIXMAP_DATA, select_all_xpm, 'A', GDK_MOD1_MASK, 0 },
   GNOMEUIINFO_SEPARATOR,
   { GNOME_APP_UI_ITEM, _("Re-Highlight"), _("Re-Highlight the current file"), (gpointer)highlight_syntax_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CONVERT, GDK_F4, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_SEPARATOR,
   { GNOME_APP_UI_ITEM, _("P_roperties"), _("Edit properties"), (gpointer)edit_properties, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PROPERTIES, 0, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_END
};

GnomeUIInfo search_menu[] = {
   GNOMEUIINFO_MENU_FIND_ITEM((gpointer)find_cb, 0),
   GNOMEUIINFO_MENU_REPLACE_ITEM((gpointer)replace_cb, 0),
   { GNOME_APP_UI_ITEM, _("Goto Line"), _("Goto a line"), (gpointer)gotoline_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_JUMP_TO, 'L', GDK_CONTROL_MASK, 0 },
   { GNOME_APP_UI_ITEM, _("Search Manpages"), _("Search manpages"), (gpointer)manpage_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_INDEX, GDK_F1, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_END
};

GnomeUIInfo insert_menu[] = {
   GNOMEUIINFO_ITEM_NONE(_("_Insert File"), _("Insert a file"), (gpointer)insert_file_cb),
   GNOMEUIINFO_ITEM_NONE(_("_Ascii Character"), _("Insert a chracter from the chooser"), (gpointer)insert_ascii_char_cb),
   GNOMEUIINFO_ITEM_NONE(_("_Shell Output"), _("Insert output from a command"), (gpointer)runcmd_cb),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_ITEM_NONE(_("ChangeLog _Entry"), _("Insert ChangeLog entry"), (gpointer)insert_changelog_string),
   GNOMEUIINFO_ITEM_NONE(_("_Date & Time"), _("Insert current date and time"), (gpointer)insert_date_time),         
   GNOMEUIINFO_ITEM_NONE(_("_User Name"), _("Insert the name of the current user"), (gpointer)insert_username),         
   GNOMEUIINFO_ITEM_NONE(_("_Name"), _("Insert name (from prefs)"), (gpointer)insert_name),
   GNOMEUIINFO_ITEM_NONE(_("Email _Address"), _("Insert email (from prefs)"), (gpointer)insert_email),         
   GNOMEUIINFO_ITEM_NONE(_("_GPL Notice (C)"), _("Insert GPL notice"), (gpointer)insert_gpl_notice),
   GNOMEUIINFO_ITEM_NONE(_("G_PL Notice (C++)"), _("Insert GPL notice"), (gpointer)insert_gpl_noticepp),
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_END
};

GnomeUIInfo build_menu[] = {
   { GNOME_APP_UI_ITEM, _("_Compile"), _("Compile the current source file"), (gpointer)compile_file_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_EXEC, GDK_F5, (GdkModifierType) 0, 0 },
   { GNOME_APP_UI_ITEM, _("_Debug"), _("Debug the current source file"), (gpointer)debug_file_cb, 0, 0, GNOME_APP_PIXMAP_DATA, debug_xpm, GDK_F5, GDK_CONTROL_MASK, 0 },
   { GNOME_APP_UI_ITEM, _("_Execute"), _("Execute the current program"), (gpointer)execute_file_cb, 0, 0, GNOME_APP_PIXMAP_DATA, dotslash_xpm, GDK_F5, GDK_SHIFT_MASK, 0 },
   { GNOME_APP_UI_ITEM, _("Clear _Window"), _("Clear the compiler output window"), (gpointer)clear_list_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR, 0, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_END
};

#ifdef USE_PYTHON
GnomeUIInfo scripts_menu[] = {
   { GNOME_APP_UI_ITEM, _("_Regenerate Menu"), _("Regenerate the scripts menu"), (gpointer)regenerate_scripts_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CONVERT, 0, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_END
};
#endif

GnomeUIInfo settings_menu[] = {
   GNOMEUIINFO_MENU_PREFERENCES_ITEM((gpointer)edit_preferences, 0),
   GNOMEUIINFO_END
};

GnomeUIInfo window_menu[] = {
   { GNOME_APP_UI_ITEM, _("_New Main Window"), _("New instance of CodeCommander"), (gpointer)new_window_cb, 0, 0, GNOME_APP_PIXMAP_DATA, window_xpm, 0, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_SEPARATOR,
   GNOMEUIINFO_END
};

GnomeUIInfo session_menu[] = {
   { GNOME_APP_UI_ITEM, _("_Save Current Session"), _("Save the current session"), (gpointer)save_session_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE, 0, (GdkModifierType) 0, 0 },
   { GNOME_APP_UI_ITEM, _("_Open Session"), _("Open a session"), (gpointer)open_session_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_OPEN, 0, (GdkModifierType) 0, 0 },
   { GNOME_APP_UI_ITEM, _("Save Session _As"), _("Save the current session with a different name"), (gpointer)save_session_as_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE_AS, 0, (GdkModifierType) 0, 0 },
   GNOMEUIINFO_END
};

GnomeUIInfo help_menu[] = {
   GNOMEUIINFO_SEPARATOR,
   { GNOME_APP_UI_ITEM, _("_README"), _("View README file"), (gpointer)do_contents_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_INDEX, 0, (GdkModifierType) 0, 0 },
   { GNOME_APP_UI_ITEM, _("_License"), _("View License agreement"), (gpointer)do_license_cb, 0, 0, GNOME_APP_PIXMAP_DATA, gnu_gpl_xpm, 0, (GdkModifierType) 0, 0 },
   { GNOME_APP_UI_ITEM, _("_ChangeLog"), _("View latest changes"), (gpointer)do_changes_cb, 0, 0, GNOME_APP_PIXMAP_DATA, arrow_xpm, 0, (GdkModifierType) 0, 0 },
   { GNOME_APP_UI_ITEM, _("Language _Definitions"), _("Informaton on CodeCommander Language Definitions"), (gpointer)do_langs_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_ATTACH, 0, (GdkModifierType) 0, 0 },
#ifdef USE_PYTHON
   { GNOME_APP_UI_ITEM, _("_Python Scripting"), _("View Python Information file"), (gpointer)do_python_cb, 0, 0, GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_INDEX, 0, (GdkModifierType) 0, 0 },
#endif
   GNOMEUIINFO_MENU_ABOUT_ITEM((gpointer)do_about, 0),
   GNOMEUIINFO_END
};

GnomeUIInfo menubar[] = {
   GNOMEUIINFO_SUBTREE(_("_File"), file_menu),
   GNOMEUIINFO_SUBTREE(_("_Edit"), edit_menu),
   GNOMEUIINFO_SUBTREE(_("_Search"), search_menu),
   GNOMEUIINFO_SUBTREE(_("_Insert"), insert_menu),
   GNOMEUIINFO_SUBTREE(_("_Build"), build_menu),
#ifdef USE_PYTHON
   GNOMEUIINFO_SUBTREE(_("_Scripts"), scripts_menu),
#endif
   GNOMEUIINFO_SUBTREE(_("Se_ttings"), settings_menu),
   GNOMEUIINFO_SUBTREE(_("_Windows"), window_menu),
   GNOMEUIINFO_SUBTREE(_("Sessio_n"), session_menu),
   GNOMEUIINFO_SUBTREE(_("_Help"), help_menu),
   GNOMEUIINFO_END
};

static GtkItemFactoryEntry popup_items[] = {
   { _("/_File"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/File/_Save"), NULL, GTK_SIGNAL_FUNC(save_file_cb), 0, NULL },
   { _("/File/Save _As"), NULL, GTK_SIGNAL_FUNC(save_file_as_cb), 0, NULL },
   { _("/File/_Close"), NULL, GTK_SIGNAL_FUNC(close_file_cb), 0, NULL },
   { _("/File/sep1"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/File/Save Current Session"), NULL, GTK_SIGNAL_FUNC(save_session_cb), 0, NULL },	 
   { _("/_Edit"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/Edit/_Cut"), NULL, GTK_SIGNAL_FUNC(cut_text_cb), 0, NULL },
   { _("/Edit/C_opy"), NULL, GTK_SIGNAL_FUNC(copy_text_cb), 0, NULL },
   { _("/Edit/_Paste"), NULL, GTK_SIGNAL_FUNC(paste_text_cb), 0, NULL },
   { _("/Edit/sep2"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/C_lear"), NULL, GTK_SIGNAL_FUNC(clear_text_cb), 0, NULL },
#ifdef USE_PYTHON
   { _("/Edit/Clear _Entry"), NULL, GTK_SIGNAL_FUNC(clear_entry_cb), 0, NULL },
#endif
   { _("/Edit/sep3"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/Comment _Selection"), NULL, GTK_SIGNAL_FUNC(comment_selection_cb), 0, NULL },
   { _("/Edit/Select Current"), NULL, GTK_SIGNAL_FUNC(select_current_cb), 0, NULL },
   { _("/Edit/Select _All"), NULL, GTK_SIGNAL_FUNC(select_all_text_cb), 0, NULL },
   { _("/Edit/sep4"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/Re-Highlight"), NULL, GTK_SIGNAL_FUNC(highlight_syntax_cb), 0, NULL },
   { _("/Edit/sep5"), NULL, (GtkSignalFunc)NULL, 0, "<Separator>" },
   { _("/Edit/P_roperties"), NULL, GTK_SIGNAL_FUNC(edit_properties), 0, NULL },
   { _("/_Search"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/Search/_Find"), NULL, GTK_SIGNAL_FUNC(find_cb), 0, NULL },
   { _("/Search/_Replace"), NULL, GTK_SIGNAL_FUNC(replace_cb), 0, NULL },
   { _("/Search/_Goto Line"), NULL, GTK_SIGNAL_FUNC(gotoline_cb), 0, NULL },
   { _("/Search/_Search Manpages"), NULL, GTK_SIGNAL_FUNC(manpage_cb), 0, NULL },
   { _("/_Build"), NULL, (GtkSignalFunc)NULL, 0, "<Branch>" },
   { _("/Build/_Compile"), NULL, GTK_SIGNAL_FUNC(compile_file_cb), 0, NULL },
   { _("/Build/_Debug"), NULL, GTK_SIGNAL_FUNC(debug_file_cb), 0, NULL },
   { _("/Build/_Execute"), NULL, GTK_SIGNAL_FUNC(execute_file_cb), 0, NULL },
   { _("/Build/Clear Window"), NULL, GTK_SIGNAL_FUNC(clear_list_cb), 0, NULL },
};

void make_menus()
{
   GtkItemFactory *item_factory;
   gint nmenu_items;
   gnome_app_create_menus(GNOME_APP(window), menubar);
   gnome_app_install_appbar_menu_hints(GNOME_APPBAR(appbar), menubar);

   filemenu = menubar[0].widget;
   recentmenu = recent_menu[0].widget->parent;
   editmenu = menubar[1].widget;
   searchmenu = menubar[2].widget;
   insertmenu = insert_menu[0].widget->parent;
   insertmenutitle = menubar[3].widget;
   buildmenu = menubar[4].widget;
#ifdef USE_PYTHON
   scriptsmenu = scripts_menu[0].widget->parent;
#endif
   settingsmenu = menubar[6].widget;
   windowmenu = window_menu[0].widget->parent;
   sessionmenu = menubar[8].widget;
   helpmenu = menubar[9].widget;

   file_menu_new = file_menu[0].widget;
   file_menu_open = file_menu[1].widget;
   file_menu_revert = file_menu[2].widget;
   file_menu_save = file_menu[4].widget;
   file_menu_saveas = file_menu[5].widget;
   file_menu_save_all = file_menu[6].widget;
   file_menu_close = file_menu[8].widget;
   file_menu_close_all = file_menu[9].widget;
   edit_menu_undo = edit_menu[0].widget;   
   edit_menu_redo = edit_menu[1].widget;   

   nmenu_items = sizeof(popup_items) / sizeof(popup_items[0]);
   item_factory = gtk_item_factory_new(GTK_TYPE_MENU, "<edit popup>", 0);
   gtk_item_factory_create_items(item_factory, nmenu_items, popup_items, 0);

   edit_popup_menu = gtk_item_factory_get_widget(item_factory, "<edit popup>");
   gtk_widget_show(edit_popup_menu);
}
