
#ifndef SEARCHES_H_
#define SEARCHES_H_

#include "widgets/gnomesearchdialog.h"
#include "widgets/gnomegotoline.h"
#include "widgets/gdsmanpage.h"

void find_cb(GtkWidget *widget, gpointer data);
void find_text_cb(GtkWidget *widget, GnomeSearchDialog *search_dialog);
gboolean find_text(GtkExText *extext, gint start, gint end, gchar *search_string, gboolean case_sensitive, gboolean is_regex, gboolean select, GtkExTextMatch *match);

void replace_cb(GtkWidget *widget, gpointer data);
void replace_text_cb(GtkWidget *widget, GnomeSearchDialog *search_dialog);
void replace_all_text_cb(GtkWidget *widget, GnomeSearchDialog *search_dialog);
gint replace_all_text(GtkExText *extext, gchar *search_text, gchar *replace_text, gboolean iscase, gint end);
gboolean replace_text(GtkExText *extext, gchar *text);

void gotoline_cb(GtkWidget *widget, gpointer data);
void find_line_cb(GtkWidget *widget, GnomeGotoLineDialog *gtl);

void manpage_cb(GtkWidget *widget, gpointer data);
void make_manpage_viewer(gchar *text);

void set_find_text_from_selection(GnomeSearchDialog *sd);
GList *build_glist_from_file(gchar *filename, guint max);
void add_string_to_file(gchar *filename, const gchar *string);

gint get_selection_length(GtkEditable *editable);
gchar *get_selection_text(GtkEditable *editable);
gint get_entry_length(GtkEntry *entry);
gchar *get_entry_text(GtkEntry *entry);
gint check_list_for_string(GList *list, gchar *string);
#endif
