
#ifndef SETTINGS_H
#define SETTINGS_H
void edit_preferences(GtkWidget *widget, gpointer data);
void save_settings(GtkWidget *widget, gpointer data);
void apply_settings(GtkWidget *widget, gpointer data);
void get_defaults(GtkWidget *widget, gpointer data);
void get_theme_defaults(GtkWidget *widget, gpointer data);
void get_backups(GtkWidget *widget, gpointer data);
void redo_backups(GtkWidget *widget, gpointer data);

struct preferences{
   gchar default_dir[256];
   gchar projects_dir[256];
   gint syntax;
   gint history;
   gint save_session;
   gint open_session;
   gint undo_max;
   gchar name[256];
   gchar email[256];
   gint notebook_tab_position;
   gboolean use_gtk_theme;
   gchar font_name[256];
   GdkFont *font;
   GdkColor fg;
   GdkColor bg;
   GdkColor s_fg;
   GdkColor s_bg;
   gboolean auto_indent;
   gboolean use_spaces;
   guint spaces;
};

typedef struct preferences Preferences;

void get_preferences(Preferences *source);
void put_preferences(Preferences *source);
void copy_preferences(Preferences *source, Preferences *dest);

GtkWidget *make_button(gchar *button_text, GtkWidget *which_box, gint *value);
void set_font_changed(GnomeFontPicker *gfp, gchar *font_name, gpointer data);
void set_color_changed(GtkWidget *cp, guint r, guint g, guint b, guint a, gpointer data);
void gtk_theme_switch_cb(GtkWidget *widget, gint *value);
void apply_settings_changes();
void kill_widget_ptr(GtkWidget *w, GtkWidget **widget);

extern Preferences general_preferences;
extern Preferences backup_preferences;
extern Preferences default_preferences;

#endif

